<?php

/**
* @copyright	Copyright (C) 2009 - 2009 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage	User-Detail
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans User Detail Plugin
 *
 */
class plgPayplansUserdetail extends XiPlugin
{

	public function onPayplansSystemStart()
	{
		//add userdetails app path to app loader
		$appPath = dirname(__FILE__).DS.'userdetail'.DS.'app';
		PayplansHelperApp::addAppsPath($appPath);

		return true;
	}
	
	public function onPayplansAppAfterSave($prev, $new)
	{
		if(false == ($new instanceof PayplansAppUserdetail)){
			return true;
		}

		$appid = $new->getId();
		$location = $new->getLocation();
		$path = $location.DS.'xmldata'.DS."userdetail_app_$appid.xml";
		
		$param = base64_decode($new->getAppParam('additional'));	
	
		//delete the existing file if any
		if(JFile::exists($path)){
			JFile::delete($path);	
		}

		JFile::write($path, $param);
		return true;
	}
	
	public function onPayplansUserdetailSaveRequest($fields)
	{
		if(empty($fields)){
			return true;
		}

		$userid = XiFactory::getUser()->id;
		if(!$userid){
			// show error message
			return true;
		}
		
		$data = array();
		foreach($fields as $field){
			if(strncmp($field['name'], 'params',6)==0){
				$data[$field['name']]= $field['value'];
			}
		}
		
		$user = PayplansUser::getInstance($userid);
		
		$args = array(&$user, &$data);
		$result = PayplansHelperEvent::trigger('onPayplansUserdetailSave', $args, '', $user);
				
		$user->save();

		//XITODO : Send success or error message
		$response = XiFactory::getAjaxResponse();
		$response->sendResponse();
	}
	
	function onPayplansRewriterDisplayTokens()
	{
		$userDetailApp  = PayplansHelperApp::getAvailableApps('userdetail');

		//if no app exists then don't create tab 
		if(empty($userDetailApp)){
			return ;
		}
		?>
		
		<?php 
		$rewriterToken   	= array();
		$userparams 		= '';
		//set the tokens
		foreach ($userDetailApp as $app){
			$name     = $app->getName(); 
			$appid    = $app->getId();
			$location = $app->getLocation();
			$path     = $location.DS.'xmldata'.DS."userdetail_app_{$appid}.xml";
			$xml      = file_get_contents($path);
            if (trim($xml) == '') {
                   return true;
            }
			$form = JForm::getInstance('user.userDetail'.$appid, $path ,array(),true, '//config');
			foreach ($form->getFieldset('params') as $field){
				$userparams[$field->fieldname] = $field->value;
			}		

			if(!is_array($userparams) || empty($userparams)){
				continue ;
			}
			
			foreach($userparams as $key => $value){
				$rewriterToken[JString::strtoupper($name.'_'.$key)] = 0 ;
			}
		}
		$contentLi = '<li><a href="#User_detail" data-toggle="tab">User Detail</a></li>';
		$contentsTab = '<div class="tab-pane" id="User_detail">';
		foreach($rewriterToken as $key => $val){			
			$contentsTab .= '[['.$key.']]<br/>';			
		}
		$contentsTab .= "</div>"; 
		return array($contentLi, $contentsTab);
	}
}
